/***************************************************************************
 *   Copyright (C) 2006 by Ken Werner                                      *
 *   ken.werner@web.de                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "cpuinfofreqsrc.h"
#include <qtextstream.h> 

CpuinfoFreqSrc::CpuinfoFreqSrc(const QFile& inSourceFile):
		Source(inSourceFile){
	mName = "proc";
	mDescription = "This source is provided by the Linux kernel /proc/cpuinfo interface.";
}

CpuinfoFreqSrc::~CpuinfoFreqSrc(){
}

QString CpuinfoFreqSrc::getValue(){
	QString s = "n/a";
	if(mSourceFile.open(IO_ReadOnly)){
		QTextStream textStream( &mSourceFile );
		while( mSourceFile.readLine( s, 64 ) != -1 )
			if( s.startsWith( "cpu MHz") )
				break;
		s = s.section( ':', 1, 1 ).stripWhiteSpace();
		s = KHzinHumanReadable(s.toDouble() * 1000);
		mSourceFile.close();
	}
	return s;
}
